HDU 1814 Peaceful Commission / HIT 1917 Peaceful Commission /CJOJ 1288 和平委员会

HDU 1814 Peaceful Commission / HIT 1917 Peaceful Commission /CJOJ 1288 和平委员会(2-sat模板题)

Description

The Public Peace Commission should be legislated in Parliament of The Democratic Republic of Byteland according to The Very Important Law. Unfortunately one of the obstacles is the fact that some deputies do not get on with some others.

The Commission has to fulfill the following conditions:
1.Each party has exactly one representative in the Commission,
2.If two deputies do not like each other, they cannot both belong to the Commission.

Each party has exactly two deputies in the Parliament. All of them are numbered from 1 to 2n. Deputies with numbers 2i-1 and 2i belong to the i-th party .

Task
Write a program, which:
1.reads the number of parties and the pairs of deputies that are not on friendly terms,
2.decides whether it is possible to establish the Commission, and if so, proposes the list of members,
3.writes the result

Input

In the first line there are two non-negative integers n and m. They denote respectively: the number of parties, 1 <= n <= 8000, and the number of pairs of deputies, who do not like each other, 0 <= m <=2 0000. In each of the following m lines there is written one pair of integers a and b, 1 <= a < b <= 2n, separated by a single space. It means that the deputies a and b do not like each other.
There are multiple test cases.

Output

The text should contain one word NIE (means NO in Polish), if the setting up of the Commission is impossible. In case when setting up of the Commission is possible the file should contain n integers from the interval from 1 to 2n, written in the ascending order, indicating numbers of deputies who can form the Commission. Each of these numbers should be written in a separate line. If the Commission can be formed in various ways, your program may write mininum number sequence.

Sample Input

3 2
1 3
2 4

Sample Output

1
4
5

Http

HDU:https://vjudge.net/problem/HDU-1814
HIT:https://vjudge.net/problem/HIT-1917
CJOJ:http://oj.changjun.com.cn/problem/detail/pid/1288

Source

2-sat

翻译(By CJOJ)

根据宪法,Byteland民主共和国的公众和平委员会应该在国会中通过立法程序来创立。 不幸的是,由于某些党派代表之间的不和睦而使得这件事存在障碍。
此委员会必须满足下列条件:
每个党派都在委员会中恰有1个代表,
如果2个代表彼此厌恶,则他们不能都属于委员会。
每个党在议会中有2个代表。代表从1编号到2n。 编号为2i-1和2i的代表属于第I个党派。
任务
写一程序:
输入党派的数量和关系不友好的代表对,
计算决定建立和平委员会是否可能,若行,则列出委员会的成员表。

题目大意

有n个组,每组里有两个元素,现在给出m对元素不能都选择的条件,求一个集合使得每组里面恰好选择了一个元素且满足上述m对条件

解决思路

这是一道2-sat的模板题。

我们设i和i’表示一个党派中的两个人,那么如果i与j不能够共存,则说明若选i则必须选j’,同理,若选j则必须选择j’。由此,我们可以建边连图。对于互相厌恶的两个代表i,j连边i->j’j->i’。注意这是有向边

为什么是有向边呢?

因为i与j互相厌恶不代表i’与j’互相厌恶,如果连了边j’->i,那么意思是选j’必须选i(同时也表示一定不能选i’),但j’与i并不一定互相厌恶,所以连的边一定是有向边。

然后就是判断的方法。因为题目要求要按字典序输出,所以对于每一组,我们先检查标号较小的那个(i),如果不行,再检查编号大的(i+1)

另外一点需要注意的是,由于要求字典序输出,所以不能使用Tarjan缩点+拓扑排序的方法,只能用dfs一个一个判断

代码

//暴力染色法
#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<vector>
using namespace std;

#define Other(x) ((x%2==0) ? (x-1) : (x+1) ) //Other(x) 表示与x同党派的另一个人。这里用i和i+1来表示同党派的两个人(i为奇数)

const int maxN=16050;
const int inf=2147483647;

int n,m;
int cnt;
vector<int> E[maxN];//用来存放边
int color[maxN];//存染色时每个点的颜色,0代表还没有填,1和2分别代表两种颜色
int Ans[maxN];//临时存放答案

bool solve();//循环染色
bool dfs(int x);//检查是否满足没有矛盾

int main()
{
    while (cin>>n>>m)
    {
        n=n*2;
        int a,b;
        for (int i=1;i<=n;i++)
            E[i].clear();//因为HDU上是多组数据,所以每一次都要重新清空
        for (int i=1;i<=m;i++)
        {
            cin>>a>>b;
            E[a].push_back(Other(b));
            E[b].push_back(Other(a));
        }
        if (solve())
        {
            for (int i=1;i<=n;i++)//输出所有被染成1色的点
                if (color[i]==1)
                    cout<<i<<endl;
        }
        else
            cout<<"NIE"<<endl;
    }
}

bool solve()
{
    memset(color,0,sizeof(color));
    for (int i=1;i<=n;i++)
    {
        if (color[i]!=0)//如果这个点已经被染色(即前面已经给其染过色)
            continue;
        cnt=0;//临时保存答案的计数器
        if (!dfs(i))//先尝试把i染成1,若不行则在下面选择Other(i)
        {
            for (int j=1;j<=cnt;j++)//若要选择Other(i)则要把之前检查i是否满足时用到的数组清空
            {
                color[Ans[j]]=0;
                color[Other(Ans[j])]=0;
            }
            cnt=0;//感谢dsl大佬的查错,这里要加cnt=0,虽然说不加程序并不会出错,但是会浪费一堆空间,若数据大时可能会出问题
            if (!dfs(Other(i)))//如果把Other(i)也染成1也不满足,说明无解
                return 0;
        }
    }
    return 1;
}

bool dfs(int x)
{
    if (color[x]==1)//如果该点已被染成1,说明满足并返回
        return 1;
    if (color[x]==2)//如果该点已被染成2,说明矛盾
        return 0;
    color[x]=1;//把这一点染成1
    color[Other(x)]=2;//把其相对的点染成2
    cnt++;
    Ans[cnt]=x;//把这一点放入Ans中,方便后面清空
    for (int i=0;i<E[x].size();i++)//传递染色
        if (!dfs(E[x][i]))//如果传递失败,说明矛盾
            return 0;
    return 1;
}
  • 2
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 6
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论 6
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值